
get.conn.rank <- function(pattern, graph, control)
{
  # Create an empty vector to hold the control patches
  
  require(spatgraphs)
  require(igraph)
  
  controlPatches <- c()
  
  
  # Spatgraph to iGraph
  ig <- sg2igraph(graph, pp = pattern)
  #ig <- graph_from_adj_list(graph$edges)
  
  # Select the patches to be controlled
  for (n in seq(1, control)) {
  
  if (n == 1) { # if this is the first patch selection use original graph
    
    # Calculate betweenness centrality
    bc <- betweenness(ig, v = V(ig))
    # Plot the betweenness centrality for the whole graph
    # symbols(x, y, bc/max(bc)/20, fg="red", add=T, inches=F)
    # Determine top connected node and remove
    topNode <- names(sort(bc, decreasing = T)[1])
    # Add to control patches
    controlPatches = c(controlPatches, topNode)
    # And remove from the graph
    igNew = delete.vertices(ig, topNode)
    
  } else { # if this isn't the first patch selection
    
    # Calculate betweenness centrality from the reduced graph
    bc = betweenness(igNew, v = V(igNew))
    # Determine top connected node
    topNode = names(sort(bc, decreasing = T)[1])
    # Add to control patches
    controlPatches = c(controlPatches, topNode)
    # And remove from the graph
    igNew = delete.vertices(igNew, topNode)

    }
  }
  controlPatches  
}  